/*147 words*/
/// FAT iterate through folder(s)
auto s_int16 HandleDir(register __i2 __y struct FRAGMENT *curFragment,
											 __y struct FRAGMENT *nextFragment) {
	register __c1 int i = 0;
	register u_int32 currentSector = curFragment->start /*& 0x7fffffffUL */;
	static u_int16 lfnReset = 0;
	
#ifdef ENABLE_WATCHDOG
	USEX(WDOG_RESET) = WDOG_RESET_VAL;
#endif
	goto first;
	
	while (1) {
		register __d1 u_int16 fn = GetByte(i+0); /* first char of filename */
		
		/* We are now looking at FAT directory structure. */
		/* Is current file a regular file? */
		if (fn == 0)
			goto eod; /*end of directory*/
		if (fn != 0xe5) { /* Not deleted */								 
			// Long file name
			if ((GetByte(i+11/*Attr*/) & 0x3f) == 0x0f) {
				register u_int16 idx = ((fn & 0x3f) - 1) * 13;
				static const short places[] = {
					1, 3, 5, 7, 9, 14, 16, 18, 20, 22, 24, 28, 30, -1
				};
				register const short *p = &places[0];
				while (*p >= 0 && idx < FAT_LFN_SIZE-1 /* space for NUL */) {
					longFileName[idx++] =
						GetByte(i + *p++);
				}
				/* last long entry ? */
				if ( fn & 0x40 /*LAST_LONG_ENTRY*/ ) {
					if (idx >= FAT_LFN_SIZE)
						idx = FAT_LFN_SIZE-1;
					longFileName[idx] = '\0';
				}
				lfnReset = 0;
			} else {
				if (++lfnReset==2) {
					longFileName[0] = 0;
				}
			}
			
			
#ifdef WITH_SUBDIRECTORIES
			/* Is it a subdirectory? */
			if ((GetByte(i+11/*Attr*/) & 0x10) && fn != '.') {
				/* TODO: do not call if FAT12! */
				if (HandleDir(nextFragment,
											FragmentList(nextFragment,
																	 ((u_int32)GetWord(i+20)<<16)+GetWord(i+26))) < 0)
					return -1;
				//puts("reread dir");
				memset(stream_buffer, 0, 512/2);
				ReadDiskSector(currentSector);/*reread sector*/
			} else /* it was a subdirectory */
#endif
				/* Attributes: NO directory, NO volume id, NO system, NO hidden */
				if ((GetByte(i+11/*Attr*/) & 0xde) == 0
#ifdef CHECKFILETYPE
						/*
							check supported files from name suffix:
							vs1011/vs1002:	wav mp3
							vs1003:					wav mp3 mid wma asf
							vs1033: wav mp3 mid wma asf mp4 aac m4a
						*/
						&& CHECKFILETYPE(GetLong(i+8))
#endif
						) {
					
					/* It is a regular file. */
					
					gFileNum[1]++; /* total file count */
					if (gFileNum[0]-- == 0) {
					thisfile:
						/* Put the 8.3-character filename to memory so the user
							 can read it. Two bytes per word, big-endian. */
						{		/* 13 words */
							register int j;
							register u_int16 *p = stream_buffer + i/2;
							register __y u_int16 *d = fileName;
							for (j=0;j<6;j++) {
								*d++ = *p++;
							}
						}

						/* ------------ FILE FOUND ------------- */
						fatInfo.fileSize = GetLong(i+28); /*do first!*/
						FragmentList(&fragments[0],
												 ((u_int32)GetWord(i+20)<<16) + GetWord(i+26));
						return -1; /* File found, All OK return */
					}
				} /* normal file */
		} /* 0xe5 / 0x00 deleted or unused entry */
		i = (i + 32) & 511;
		if (i == 0) {
			currentSector++;
			if (--(curFragment->size) == 0) {
				if ((s_int16)(curFragment->start>>16) < 0) {
				eod:
					return gFileNum[1];
				}
				curFragment++;
				currentSector = curFragment->start /*& 0x7fffffffUL*/;
			}
		first:
#if 0 && defined(USE_DEBUG)
			puthex(currentSector);
			puts(" read");
#endif
			//puts("read dir");
			memset(stream_buffer, 0, 512/2);
			ReadDiskSector(currentSector);
		}
	}
}
